import { Prisma } from '@prisma/client';
import { CacheOptions, CacheQueryArgs } from './types.js';
export { CacheConfig, ClientMethodWithCache, DefaultCacheConfig, SupportedOperation, SupportedOperations } from './types.js';
export { Adapter, CacheMetadata, Database } from './storage/index.js';
export { adapterAceBase } from './storage/acebase.js';
export { adapterMemory } from './storage/memory.js';

declare function cache(opts: CacheOptions): (client: any) => {
    $extends: {
        extArgs: {
            result: {};
            model: {
                $allModels: {
                    findUnique: () => <T, A>(this: T, args?: Prisma.Exact<A, Prisma.Args<T, "findUnique"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T, Omit<A, "cache">, "findUnique">>;
                    findUniqueOrThrow: () => <T_1, A_1>(this: T_1, args?: Prisma.Exact<A_1, Prisma.Args<T_1, "findUniqueOrThrow"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_1, Omit<A_1, "cache">, "findUniqueOrThrow">>;
                    findFirst: () => <T_2, A_2>(this: T_2, args?: Prisma.Exact<A_2, Prisma.Args<T_2, "findFirst"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_2, Omit<A_2, "cache">, "findFirst">>;
                    findFirstOrThrow: () => <T_3, A_3>(this: T_3, args?: Prisma.Exact<A_3, Prisma.Args<T_3, "findFirstOrThrow"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_3, Omit<A_3, "cache">, "findFirstOrThrow">>;
                    findMany: () => <T_4, A_4>(this: T_4, args?: Prisma.Exact<A_4, Prisma.Args<T_4, "findMany"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_4, Omit<A_4, "cache">, "findMany">>;
                    count: () => <T_5, A_5>(this: T_5, args?: Prisma.Exact<A_5, Prisma.Args<T_5, "count"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_5, Omit<A_5, "cache">, "count">>;
                    aggregate: () => <T_6, A_6>(this: T_6, args?: Prisma.Exact<A_6, Prisma.Args<T_6, "aggregate"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_6, Omit<A_6, "cache">, "aggregate">>;
                    groupBy: () => <T_7, A_7>(this: T_7, args?: Prisma.Exact<A_7, Prisma.Args<T_7, "groupBy"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_7, Omit<A_7, "cache">, "groupBy">>;
                    clearCache: () => () => Promise<void>;
                };
                planet: {
                    findUnique: () => <T, A>(this: T, args?: Prisma.Exact<A, Prisma.Args<T, "findUnique"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T, Omit<A, "cache">, "findUnique">>;
                    findUniqueOrThrow: () => <T_1, A_1>(this: T_1, args?: Prisma.Exact<A_1, Prisma.Args<T_1, "findUniqueOrThrow"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_1, Omit<A_1, "cache">, "findUniqueOrThrow">>;
                    findFirst: () => <T_2, A_2>(this: T_2, args?: Prisma.Exact<A_2, Prisma.Args<T_2, "findFirst"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_2, Omit<A_2, "cache">, "findFirst">>;
                    findFirstOrThrow: () => <T_3, A_3>(this: T_3, args?: Prisma.Exact<A_3, Prisma.Args<T_3, "findFirstOrThrow"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_3, Omit<A_3, "cache">, "findFirstOrThrow">>;
                    findMany: () => <T_4, A_4>(this: T_4, args?: Prisma.Exact<A_4, Prisma.Args<T_4, "findMany"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_4, Omit<A_4, "cache">, "findMany">>;
                    count: () => <T_5, A_5>(this: T_5, args?: Prisma.Exact<A_5, Prisma.Args<T_5, "count"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_5, Omit<A_5, "cache">, "count">>;
                    aggregate: () => <T_6, A_6>(this: T_6, args?: Prisma.Exact<A_6, Prisma.Args<T_6, "aggregate"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_6, Omit<A_6, "cache">, "aggregate">>;
                    groupBy: () => <T_7, A_7>(this: T_7, args?: Prisma.Exact<A_7, Prisma.Args<T_7, "groupBy"> & Partial<CacheQueryArgs>> | undefined) => Promise<Prisma.Result<T_7, Omit<A_7, "cache">, "groupBy">>;
                    clearCache: () => () => Promise<void>;
                };
            };
            query: {};
            client: {
                clearCache: () => () => Promise<void>;
            };
        };
    };
};

export { CacheOptions, CacheQueryArgs, cache };
//# sourceMappingURL=index.d.ts.map
